abuild.in 54.7 KB
Newer Older
Natanael Copa's avatar
Natanael Copa committed
1 2
#!/bin/sh

3
# abuild - build apk packages (light version of makepkg)
4
# Copyright (c) 2008-2015 Natanael Copa <ncopa@alpinelinux.org>
Natanael Copa's avatar
Natanael Copa committed
5 6 7 8
#
# Distributed under GPL-2
#

9
program_version=@VERSION@
Natanael Copa's avatar
Natanael Copa committed
10
sysconfdir=@sysconfdir@
11
abuildrepo_base=@abuildrepo@
Natanael Copa's avatar
Natanael Copa committed
12
datadir=@datadir@
Natanael Copa's avatar
Natanael Copa committed
13

14
abuild_path=$(readlink -f $0)
Natanael Copa's avatar
Natanael Copa committed
15

16 17 18 19 20 21
if ! [ -f "$datadir/functions.sh" ]; then
	echo "$datadir/functions.sh: not found" >&2
	exit 1
fi
. "$datadir/functions.sh"

Natanael Copa's avatar
Natanael Copa committed
22
# defaults
23
BUILD_BASE="build-base"
24

25 26 27 28 29
: ${FAKEROOT:="fakeroot"}
: ${SUDO_APK:="abuild-apk"}
: ${APK:="apk"}
: ${ADDUSER:="abuild-adduser"}
: ${ADDGROUP:="abuild-addgroup"}
30

31
apk_opt_wait="--wait 30"
32

Kaarle Ritvanen's avatar
Kaarle Ritvanen committed
33 34
umask 022

35 36 37 38 39
# run optional log command for remote logging
logcmd() {
	${ABUILD_LOG_CMD:-true} "$@"
	return 0
}
Natanael Copa's avatar
Natanael Copa committed
40

41
# we override the default msg, warning and error as we want the pkgname
Natanael Copa's avatar
Natanael Copa committed
42
msg() {
43
	[ -n "$quiet" ] && return 0
Natanael Copa's avatar
Natanael Copa committed
44 45 46
	local prompt="$GREEN>>>${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
47 48 49
	printf "${prompt} ${name}${fake}: %s\n" "$1" >&2
}

Natanael Copa's avatar
Natanael Copa committed
50 51 52 53
warning() {
	local prompt="${YELLOW}>>> WARNING:${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
54 55 56
	printf "${prompt} ${name}${fake}: %s\n" "$1" >&2
}

Natanael Copa's avatar
Natanael Copa committed
57 58 59 60
error() {
	local prompt="${RED}>>> ERROR:${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
61
	printf "${prompt} ${name}${fake}: %s\n" "$1" >&2
62
	logcmd "ERROR: $pkgname: $1"
63 64
}

65 66 67 68
cross_compiling() {
	test "$CBUILD" != "$CHOST" -a -n "$CBUILDROOT"
}

Linux User's avatar
Linux User committed
69
cleanup() {
70
	local i=
Linux User's avatar
Linux User committed
71
	set_xterm_title ""
72 73 74
	if [ -n "$CLEANUP_FILES" ]; then
		rm -f $CLEANUP_FILES
	fi
75 76 77 78 79 80 81
	for i; do
		case $i in
		pkgdir) msg "Cleaning up pkgdir"; rm -rf "$pkgbasedir";;
		srcdir) msg "Cleaning up srcdir"; rm -rf "$srcdir";;
		deps)
			if [ -z "$install_after" ] && [ -n "$uninstall_after" ]; then
				msg "Uninstalling dependencies..."
82
				$SUDO_APK del --quiet $apk_opt_wait $uninstall_after
83
				if cross_compiling; then
84 85 86 87
					$SUDO_APK del --root "$CBUILDROOT" \
						--quiet $apk_opt_wait \
						$uninstall_after
				fi
88 89 90 91
			fi
			;;
		esac
	done
Linux User's avatar
Linux User committed
92 93
}

Natanael Copa's avatar
Natanael Copa committed
94
die() {
Linux User's avatar
Linux User committed
95
	error "$@"
96
	cleanup $ERROR_CLEANUP
Natanael Copa's avatar
Natanael Copa committed
97 98 99
	exit 1
}

100 101 102 103
spell_error() {
	die "APKBUILD contains '$1'. It should be '$2'"
}

104
# check if apkbuild is basicly sane
105
default_sanitycheck() {
106
	local i= j= suggestion=
107
	msg "Checking sanity of $APKBUILD..."
108 109 110
	[ -z "$pkgname" ] && die "Missing pkgname in APKBUILD"
	[ -z "${pkgname##* *}" ] && die "pkgname contains spaces"
	[ -z "$pkgver" ] && die "Missing pkgver in APKBUILD"
111
	if [ "$pkgver" != "volatile" ] && [ -z "$nodeps" ]; then
112
		$APK version --check --quiet "$pkgver" ||\
113 114
			die "$pkgver is not a valid version"
	fi
115
	[ -z "$pkgrel" ] && die "Missing pkgrel in APKBUILD"
116 117 118
	[ -z "$pkgdesc" ] && die "Missing pkgdesc in APKBUILD"
	[ -z "$url" ] && die "Missing url in APKBUILD"
	[ -z "$license" ] && die "Missing license in APKBULID"
119 120 121
	if [ $(echo "$pkgdesc" | wc -c) -gt 128 ]; then
		die "pkgdesc is too long"
	fi
122
	is_function package || warning "Missing package() function in APKBUILD"
123

124 125
	if [ -n "$replaces_priority" ] \
		&& ! echo $replaces_priority | egrep -q '^[0-9]+$'; then
126 127
		die "replaces_priority must be a number"
	fi
128 129 130 131 132 133 134
	# check so no package names starts with -
	for i in $pkgname $subpackages; do
		case $i in
		-*) die "${i%:*} is not a valid package name";;
		esac
	done

135
	# check if CARCH, CBUILD, CHOST and CTARGET is set
136 137
	[ -z "$CHOST" ] && die "Please set CHOST in /etc/abuild.conf"

138
	if [ -z "$CARCH" ]; then
Natanael Copa's avatar
Natanael Copa committed
139
		die "Please fix CHOST, or set CARCH in abuild.conf"
140
	fi
141

Natanael Copa's avatar
Natanael Copa committed
142
	for i in $install; do
143
		local n=${i%.*}
144
		local suff=${i##*.}
145 146 147 148 149
		case "$suff" in
		pre-install|post-install|pre-upgrade|post-upgrade|pre-deinstall|post-deinstall);;
		*) die "$i: unknown install script suffix"
		esac
		if ! subpackages_has "$n" && [ "$n" != "$pkgname" ]; then
150
			die "$i: install script does not match pkgname or any subpackage"
151
		fi
152
		[ -e "$startdir/$i" ] || die "install script $i is missing"
153 154 155 156 157 158
		for j in chown chmod chgrp; do
			if grep -q $j "$startdir"/$i; then
				warning "$i: found $j"
				warning2 "Permissions should be fixed in APKBUILD package()"
			fi
		done
Natanael Copa's avatar
Natanael Copa committed
159
	done
160

161 162 163
	for i in $triggers; do
		local f=${i%=*}
		local p=${f%.trigger}
164
		[ "$f" = "$i" ] && die "$f: triggers must contain '='"
165 166 167 168
		[ "$p" = "$f" ] && die "$f: triggers scripts must have .trigger suffix"
		if ! subpackages_has "$p" && [ "$p" != "$pkgname" ]; then
			die "$p: trigger script does not match pkgname or any subpackage"
		fi
Natanael Copa's avatar
Natanael Copa committed
169

170 171
		[ -e "$startdir"/$f ] || die "trigger script $f is missing"
	done
172 173
	if [ -n "$source" ]; then
		for i in $source; do
Natanael Copa's avatar
Natanael Copa committed
174 175 176 177
			if install_has "$i"; then
				warning "You should not have \$install in source"
				continue
			fi
178
			case "$i" in
179
				*::*) i=${i%%::*};;
180
				https://*) makedepends_has wget && warning "wget no longer need to be in makedepends when source has https://" ;;
181
			esac
182 183
			list_has ${i##*/} $md5sums $sha256sums $sha512sums \
				|| die "${i##*/} is missing in checksums"
184 185 186 187 188 189 190 191 192 193

			# verify that our source does not have git tag version
			# name as tarball (typicallly github)
			if is_remote "$i" && [ "${i#*::}" = "$i" ]; then
				case ${i##*/} in
				v$pkgver.tar.*|$pkgver.tar.*)
					die "source ${i##*/} needs to be renamed to avoid possible collisions"
					;;
				esac
			fi
194 195
		done
	fi
Natanael Copa's avatar
Natanael Copa committed
196

197 198 199 200 201 202 203 204
	# verify that things listed in checksum also is listed in source
	local algo=
	for algo in md5 sha256 sha512; do
		eval set -- \$${algo}sums
		while [ $# -gt 1 ]; do
			local file="$2"
			shift 2
			source_has $file || die "$file exists in ${algo}sums but is missing in source"
205
		done
206
	done
207

208
	# common spelling errors
209 210 211 212 213
	[ -n "$depend" ] && spell_error depend depends
	[ -n "$makedepend" ] && spell_error makedepend makedepends
	[ -n "$pkguser" ] && spell_error pkguser pkgusers
	[ -n "$pkggroup" ] && spell_error pkggroup pkggroups
	[ -n "$subpackage" ] && spell_error subpackage subpackages
Natanael Copa's avatar
Natanael Copa committed
214

215
	check_maintainer || die "Provide a valid RFC822 maintainer address"
216

217 218
	check_depends_dev || warning "depends_dev found but no development subpackage found"

219
	makedepends_has 'g++' && warning "g++ should not be in makedepends"
220 221 222
	return 0
}

223 224 225 226
sanitycheck() {
	default_sanitycheck
}

227 228
sumcheck() {
	local algo="$1" sums="$2"
229
	local dummy f endreturnval originalparams origin file
230 231 232 233 234 235 236 237

	# get number of checksums
	set -- $sums
	local numsums=$(( $# / 2 ))

	set -- $source
	if [ $# -ne $numsums ]; then
		die "Number of ${algo}sums($numsums) does not correspond to number of sources($#)"
238
	fi
239
	fetch || return 1
240
	msg "Checking ${algo}sums..."
Natanael Copa's avatar
Natanael Copa committed
241
	cd "$srcdir" || return 1
242 243
	IFS=$'\n'
	endreturnval=0
244
	for src in $sums; do
245
		origin=$1; shift
246
		echo "$src" | ${algo}sum -c
247
		if [ $? -ne 0 ]; then
248
			endreturnval=1
249
			is_remote $origin || continue
250
			echo "Because the remote file above failed the ${algo}sum check it will be deleted."
251 252 253 254 255 256 257 258
			echo "Rebuilding will cause it to re-download which in some cases may fix the problem."
			file=`echo "$src" | sed 's/.*[ \t\n]\(.*\)/\1/'`
			echo "Deleting: $file"
			rm $file
		fi
	done
	unset IFS
	return $endreturnval
Natanael Copa's avatar
Natanael Copa committed
259 260
}

261 262 263 264 265 266 267 268 269
# for compatibility
md5check() {
	warning "'md5check' is deprecated. Use 'verify' instead"
	sumcheck md5 "$md5sums"
}

# verify checksums
verify() {
	local verified=false algo=
270
	for algo in sha512 sha256 sha1 md5; do
271 272 273 274 275 276 277
		local sums=
		eval sums=\"\$${algo}sums\"
		if [ -z "$sums" ] || [ -z "$source" ]; then
			continue
		fi
		sumcheck "$algo" "$sums" || return 1
		verified=true
278
		break
279 280 281 282 283 284 285
	done
	if [ -n "$source" ] && ! $verified; then
		die "Use 'abuild checksum' to generate/update the checksum(s)"
	fi
	return 0
}

286 287
# verify upstream sources
sourcecheck() {
288 289 290 291 292 293 294 295
	local uri
	for uri in $source; do
		is_remote $uri || continue
		case "$uri" in
		saveas-*://*)
			uri=${uri#saveas-}
			uri=${uri%/*}
			;;
296 297 298
		*::*)
			uri=${uri##*::}
			;;
299 300
		esac
		wget -q -s "$uri" || return 1
301
	done
302
	return 0
303
}
304

Natanael Copa's avatar
Natanael Copa committed
305 306
uri_fetch() {
	local uri="$1"
307
	[ -n "$quiet" ] && opts="-s"
308

Natanael Copa's avatar
Natanael Copa committed
309
	mkdir -p "$SRCDEST"
310
	abuild-fetch -d "$SRCDEST" "$uri"
Natanael Copa's avatar
Natanael Copa committed
311 312
}

313
is_remote() {
314
	case "${1#*::}" in
315
		http://*|ftp://*|https://*|saveas-*://*)
316 317 318 319 320
			return 0;;
	esac
	return 1
}

321 322 323 324 325 326 327 328 329
filename_from_uri() {
	local uri="$1"
	local filename="${uri##*/}"  # $(basename $uri)
	case "$uri" in
	*::*) filename=${uri%%::*};;
	esac
	echo "$filename"
}

330 331 332 333
# try download from file from mirror first
uri_fetch_mirror() {
	local uri="$1"
	if [ -n "$DISTFILES_MIRROR" ]; then
334
		if is_remote "$DISTFILES_MIRROR"; then
335 336
			uri_fetch "$DISTFILES_MIRROR"/$(filename_from_uri $uri)\
				&& return 0
337
		else
338 339
			cp "$DISTFILES_MIRROR"/$(filename_from_uri $uri) \
				"$SRCDEST" && return 0
340
		fi
341 342 343 344
	fi
	uri_fetch "$uri"
}

345
default_fetch() {
Natanael Copa's avatar
Natanael Copa committed
346 347
	local s
	mkdir -p "$srcdir"
348 349
	for s in $source; do
		if is_remote "$s"; then
350
			uri_fetch_mirror "$s" || return 1
351
			ln -sf "$SRCDEST/$(filename_from_uri $s)" "$srcdir"/
352
		else
353 354
			ln -sf "$startdir/$s" "$srcdir/"
		fi
Natanael Copa's avatar
Natanael Copa committed
355 356 357
	done
}

358 359 360 361
fetch() {
	default_fetch
}

Natanael Copa's avatar
Natanael Copa committed
362 363
# verify that all init.d scripts are openrc runscripts
initdcheck() {
364
	local i line
Natanael Copa's avatar
Natanael Copa committed
365 366
	for i in $source; do
		case $i in
367 368 369 370 371 372 373 374 375 376 377
		*.initd) line=$(head -n 1 "$srcdir"/$i);;
		*) continue ;;
		esac

		case "$line" in
		*sbin/openrc-run)
			;;
		*sbin/runscript)
			warning "$i is not an openrc #!/sbin/openrc-run"
			;;
		*)	error "$i is not an openrc #!/sbin/openrc-run"
Natanael Copa's avatar
Natanael Copa committed
378 379 380
			return 1
			;;
		esac
381
	done
Natanael Copa's avatar
Natanael Copa committed
382 383
}

Natanael Copa's avatar
Natanael Copa committed
384
# unpack the sources
385
default_unpack() {
Natanael Copa's avatar
Natanael Copa committed
386
	local u
387
	if [ -z "$force" ]; then
388
		verify || return 1
Natanael Copa's avatar
Natanael Copa committed
389
		initdcheck || return 1
390
	fi
Natanael Copa's avatar
Natanael Copa committed
391 392
	mkdir -p "$srcdir"
	for u in $source; do
393
		local s="$SRCDEST/$(filename_from_uri $u)"
Natanael Copa's avatar
Natanael Copa committed
394
		case "$s" in
395 396 397
			*.tar)
				msg "Unpacking $s..."
				tar -C "$srcdir" -xf "$s" || return 1;;
Natanael Copa's avatar
Natanael Copa committed
398
			*.tar.gz|*.tgz)
399
				msg "Unpacking $s..."
Natanael Copa's avatar
Natanael Copa committed
400 401
				tar -C "$srcdir" -zxf "$s" || return 1;;
			*.tar.bz2)
402
				msg "Unpacking $s..."
Natanael Copa's avatar
Natanael Copa committed
403
				tar -C "$srcdir" -jxf "$s" || return 1;;
404 405 406 407
			*.tar.lzma)
				msg "Unpacking $s..."
				unlzma -c "$s" | tar -C "$srcdir" -x  \
					|| return 1;;
408 409 410
			*.tar.xz)
				msg "Unpacking $s..."
				unxz -c "$s" | tar -C "$srcdir" -x || return 1;;
Natanael Copa's avatar
Natanael Copa committed
411 412 413
			*.zip)
				msg "Unpacking $s..."
				unzip "$s" -d "$srcdir" || return 1;;
Natanael Copa's avatar
Natanael Copa committed
414 415 416 417
		esac
	done
}

418 419 420 421
unpack() {
	default_unpack
}

Natanael Copa's avatar
Natanael Copa committed
422 423
# cleanup source and package dir
clean() {
424
	msg "Cleaning temporary build dirs..."
Natanael Copa's avatar
Natanael Copa committed
425
	rm -rf "$srcdir"
426
	rm -rf "$pkgbasedir"
Natanael Copa's avatar
Natanael Copa committed
427 428 429 430 431 432
}

# cleanup fetched sources
cleancache() {
	local s
	for s in $source; do
433
		if is_remote "$s"; then
434 435 436
			s=$(filename_from_uri $s)
			msg "Cleaning downloaded $s ..."
			rm -f "$SRCDEST/$s"
437
		fi
Natanael Copa's avatar
Natanael Copa committed
438 439 440
	done
}

441 442 443 444 445 446 447 448 449 450
listpkgnames() {
	local i
	for i in $pkgname $subpackages; do
		echo ${i%:*}
	done
	for i in $linguas; do
		echo $pkgname-lang-$i
	done
}

Natanael Copa's avatar
Natanael Copa committed
451 452
cleanpkg() {
	local i
453
	getpkgver || return 1
454
	msg "Cleaning built packages..."
455
	for i in $(listpkgnames); do
456 457
		local p="${i%:*}-$pkgver-r$pkgrel"
		rm -f "$PKGDEST/$p.apk" "$PKGDEST/$p.src.tar.gz" \
458
			"$abuildrepo"/$p.apk "$abuildrepo"/*/$p.apk
Natanael Copa's avatar
Natanael Copa committed
459
	done
460
	# remove given packages from index
461
	update_abuildrepo_index
Natanael Copa's avatar
Natanael Copa committed
462 463
}

464 465 466
# clean all packages except current
cleanoldpkg() {
	local i j
467
	getpkgver || return 1
468
	msg "Cleaning all packages except $pkgver-r$pkgrel..."
469
	for i in $(listpkgnames); do
470 471 472 473 474
		local pn=${i%:*}
		for j in "$PKGDEST"/$pn-[0-9]*.apk ; do
			[ "$j" = "$PKGDEST/$pn-$pkgver-r$pkgrel.apk" ] \
				&& continue
			rm -f "$j" "$abuildrepo"/*/${j##*/}
475 476
		done
	done
477
	update_abuildrepo_index
478 479
	return 0
}
480 481 482

mkusers() {
	local i
483 484 485 486 487 488
	for i in $pkggroups; do
		if ! getent group $i >/dev/null; then
			msg "Creating group $i"
			$ADDGROUP -S $i || return 1
		fi
	done
489 490
	for i in $pkgusers; do
		if ! getent passwd $i >/dev/null; then
491
			local gopt=
492
			msg "Creating user $i"
493 494 495
			if getent group $i >/dev/null; then
				gopt="-G $i"
			fi
496
			$ADDUSER -S -D -H $gopt $i || return 1
497 498 499 500
		fi
	done
}

Natanael Copa's avatar
Natanael Copa committed
501 502
# helper to update config.sub to a recent version
update_config_sub() {
503
	local changed=false
Natanael Copa's avatar
Natanael Copa committed
504
	find . -name config.sub | while read f; do
505 506
		if ! ./$f armv6-alpine-linux-muslgnueabihf 2>/dev/null; then
			msg "Updating $f"
507 508 509
			cp "$datadir"/${f##*/} "$f" || return 1
			changed=true
		else
510
			msg "No update needed for $f"
511 512 513
		fi
		# pipe subshell will return status of last command
		$changed
Natanael Copa's avatar
Natanael Copa committed
514
	done
515
	return $?
Natanael Copa's avatar
Natanael Copa committed
516
}
517

Natanael Copa's avatar
Natanael Copa committed
518 519
runpart() {
	local part=$1
520
	[ -n "$DEBUG" ] && msg "$part"
Natanael Copa's avatar
Natanael Copa committed
521 522 523 524
	$part || die "$part failed"
}

# override those in your build script
525 526 527 528 529 530 531 532
getpkgver() {
	# this func is supposed to be overridden by volatile packages
	if [ "$pkgver" = "volatile" ]; then
		error "Please provide a getpkgver() function in your APKBUILD"
		return 1
	fi
}

533 534
default_prepare() {
	local i
535 536
	cd "${builddir:-$srcdir/$pkgname-$pkgver}" \
		|| { error "Is \$builddir set correctly?"; return 1; }
537 538 539 540
	for i in $source; do
		case $i in
			*.patch)
				msg "$i"
541
				patch "${patch_args:--p1}" -i "$srcdir/$i" || return 1
542 543 544 545 546
				;;
		esac
	done
}

Natanael Copa's avatar
Natanael Copa committed
547
prepare() {
548
	default_prepare
Natanael Copa's avatar
Natanael Copa committed
549 550
}

Natanael Copa's avatar
Natanael Copa committed
551
build() {
552
	:
Natanael Copa's avatar
Natanael Copa committed
553 554
}

555 556 557
# generate a simple tar.gz package of pkgdir
targz() {
	cd "$pkgdir" || return 1
Natanael Copa's avatar
Natanael Copa committed
558
	mkdir -p "$PKGDEST"
559 560 561
	tar -czf "$PKGDEST"/$pkgname-$pkgver-r$pkgrel.tar.gz *
}

562 563 564 565 566 567 568 569 570
get_split_func() {
	# get the 'func' from "sub-pkg:func"
	local func=${1##*:}

	# get 'func' from "sub-pkg-func" if there was no :func
	[ "$func" = "$1" ] && func=${func##*-}
	echo $func
}

571 572 573
postcheck() {
	local dir="$1" name="$2" i=
	msg "Running postcheck for $name"
574
	# checking for FHS compat
Natanael Copa's avatar
Natanael Copa committed
575 576 577 578 579 580 581
	if ! options_has "!fhs"; then
		for i in "$dir"/srv/* "$dir"/usr/local/* "$dir"/opt/*; do
			if [ -e "$i" ]; then
				error "Packages must not put anything under /srv, /usr/local or /opt"
				return 1
			fi
		done
582 583 584 585
		if [ -d "$dir"/usr/var ]; then
			error "Found /usr/var, localstatedir is most likely wrong"
			return 1
		fi
Natanael Copa's avatar
Natanael Copa committed
586
	fi
587 588 589 590

	# remove *.la files if libtool is not set
	if ! options_has "libtool"; then
		find "$dir" -name '*.la' -type f -delete
591
	fi
592

593 594 595 596 597 598
	# look for /usr/lib/charset.alias
	if [ -e "$dir"/usr/lib/charset.alias ] \
			&& ! options_has "charset.alias"; then
		error "Found /usr/lib/charset.alias"
		return 1
	fi
599 600
	# look for /usr/share/doc
	if [ -e "$dir"/usr/share/doc ] \
601
			&& ! is_doc_pkg "$name"; then
602 603 604
		warning "Found /usr/share/doc but package name doesn't end with -doc"
	fi
	# look for /usr/share/man
605
	if [ -e "$dir"/usr/share/man ]; then
606
		if ! is_doc_pkg "$name"; then
607 608
			warning "Found /usr/share/man but package name doesn't end with -doc"
		fi
609
		# check for uncompressed man pages
610
		i=$(find "$dir"/usr/share/man -name '*.[0-8]' -type f | sed "s|^$dir|\t|")
611 612 613 614 615 616
		if [ -n "$i" ]; then
			error "Found uncompressed man pages:"
			echo "$i"
			return 1
		fi
	fi
617 618 619 620 621 622
	# check directory permissions
	i=$(find "$dir" -type d -perm -777 | sed "s|^$dir|\t|")
	if [ -n "$i" ]; then
		warning "World writeable directories found:"
		echo "$i"
	fi
623
	# check so we dont have any suid root binaries that are not PIE
624
	i=$(find "$dir" -type f -perm /6000 \
625 626 627 628 629 630 631
		| xargs scanelf --nobanner --etype ET_EXEC \
		| sed "s|ET_EXEC $dir|\t|")
	if [ -n "$i" ]; then
		error "Found non-PIE files that has SUID:"
		echo "$i"
		return 1
	fi
632 633 634 635 636 637 638 639 640 641 642
	# test suid bit on executable
	if ! options_has "suid"; then
		i=$(find "$dir" \( -perm -u+s -o -perm -g+s \) -a -type f \
			-a -perm -o+x)
		if [ -n "$i" ]; then
			error "Found executable files with SUID bit set:"
			echo "$i"
			return 1
		fi
	fi

643 644 645 646 647 648 649 650 651
	# test for textrels
	if ! options_has "textrels"; then
		local res="$(scanelf --recursive --textrel --quiet "$dir")"
		if [ -n "$res" ]; then
			error "Found textrels:"
			echo "$res"
			return 1
		fi
	fi
652 653 654
	return 0
}

655 656 657 658 659 660 661
pre_split() {
	if [ -z "$subpkgname" ]; then
		return 0
	fi
	# the subpackages should not inherit those form main package
	provides=""
	install_if=""
662
	apkbuild_arch="$arch"
663 664
}

665
prepare_subpackages() {
Natanael Copa's avatar
Natanael Copa committed
666 667
	local i
	cd "$startdir"
668
	for i in $subpackages; do
669 670
		local func=$(get_split_func $i)
		# call abuild recursively, setting subpkg{dir,name}
671
		msg "Running split function $func..."
672
		local dir="$pkgbasedir/${i%:*}" name="${i%:*}"
673
		( subpkgdir="$dir" subpkgname="$name" \
674
			$0 pre_split $func prepare_package \
675
			&& postcheck "$dir" "$name" ) || return 1
Natanael Copa's avatar
Natanael Copa committed
676
	done
677
	postcheck "$pkgdir" "$pkgname" || return 1
678 679
	# post check for /usr/share/locale
	if [ -d "$pkgdir"/usr/share/locale ]; then
680
		warning "Found /usr/share/locale"
681
		warning2 "Maybe add \$pkgname-lang to subpackages?"
682
	fi
Natanael Copa's avatar
Natanael Copa committed
683 684
}

685
default_lang() {
686
	pkgdesc="Languages for package $pkgname"
687 688 689 690 691 692 693 694 695 696 697 698 699
	install_if="$pkgname=$pkgver-r$pkgrel lang"
	arch="noarch"
	local dir
	for dir in ${langdir:-/usr/share/locale}; do
		mkdir -p "$subpkgdir"/${dir%/*}
		mv "$pkgdir"/"$dir" "$subpkgdir"/"$dir" || return 1
	done
}

lang() {
	default_lang
}

700
default_lang_subpkg() {
701 702 703 704
	if [ -z "$lang" ]; then
		error "lang is not set"
		return 1
	fi
705
	pkgdesc="$pkgname language pack for $lang"
706 707
	arch="noarch"
	install_if="$pkgname=$pkgver-r$pkgrel lang-$lang"
708 709 710 711 712
	local dir
	for dir in ${langdir:-/usr/share/locale}; do
		mkdir -p "$subpkgdir"/$dir
		mv "$pkgdir"/$dir/$lang* \
		"$subpkgdir"/$dir/ \
713
		|| return 1
714 715 716 717 718
	done
}

lang_subpkg() {
	default_lang_subpkg
719 720 721 722 723 724 725 726 727 728 729
}

prepare_language_packs() {
	for lang in $linguas; do
		lang="$lang" \
		subpkgname="$pkgname-lang-$lang" \
		subpkgdir="$pkgbasedir"/$subpkgname \
			$0 lang_subpkg prepare_package || return 1
	done
}

730 731 732 733 734 735 736 737 738 739 740 741
# echo '-dirty' if git is not clean
git_dirty() {
	if [ $(git status -s "$startdir" | wc -l) -ne 0 ]; then
		echo "-dirty"
	fi
}

# echo last commit hash id
git_last_commit() {
	git log --format=oneline -n 1 "$startdir" | awk '{print $1}'
}

742 743 744
get_maintainer() {
	if [ -z "$maintainer" ]; then
		maintainer=$(awk -F': ' '/\# *Maintainer/ {print $2}' "$APKBUILD")
745 746
		# remove surrounding whitespace
		maintainer=$(echo "$maintainer" | xargs)
747 748 749
	fi
}

750 751


752 753 754 755 756 757 758 759 760 761
check_maintainer() {
	get_maintainer
	if [ -z "$maintainer" ]; then
		warning "No maintainer"
	else
		# try to check for a valid rfc822 address
		case "$maintainer" in
			*[A-Za-z0-9]*\ \<*@*.*\>) ;;
			*) return 1 ;;
		esac
762 763 764
	fi
}

765
check_depends_dev() {
766 767
	if [ -z "$depends_dev" ]; then
		return 0
768
	fi
769 770 771 772 773 774 775
	local i
	for i in $pkgname $subpackages; do
		case "$i" in
			*-dev)  return 0 ;;
		esac
	done
	return 1
776 777
}

778
prepare_metafiles() {
779
	getpkgver || return 1
780 781
	local name=${subpkgname:-$pkgname}
	[ -z "${name##* *}" ] && die "package name contains spaces"
782
	local dir=${subpkgdir:-$pkgdir}
783
	local pkg="$name-$pkgver-r$pkgrel.apk"
784
	local pkginfo="$controldir"/.PKGINFO
785
	local sub
786

Natanael Copa's avatar
Natanael Copa committed
787 788
	[ ! -d "$dir" ] && die "Missing $dir"
	cd "$dir"
789
	mkdir -p "$controldir"
Natanael Copa's avatar
Natanael Copa committed
790 791
	local builddate=$(date -u "+%s")
	local size=$(du -sk | awk '{print $1 * 1024}')
Natanael Copa's avatar
Natanael Copa committed
792
	local parch="$CARCH"
793 794 795 796 797

	# we need to wait with setting noarch til our build infra can handle it
#	if [ "$arch" = "noarch" ]; then
#		parch="noarch"
#	fi
Natanael Copa's avatar
Natanael Copa committed
798

799 800 801 802 803
	# save arch incase subpackages set it different than main pkg
	if [ "${apkbuild_arch:-$arch}" != "$arch" ]; then
		echo "$arch" > "$controldir"/.arch
	fi

804
	echo "# Generated by $(basename $0) $program_version" >"$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
805
	if [ -n "$FAKEROOTKEY" ]; then
806
		echo "# using $($FAKEROOT -v)" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
807
	fi
808 809
	echo "# $(date -u)" >> "$pkginfo"
	cat >> "$pkginfo" <<EOF
810
pkgname = $name
811
pkgver = $pkgver-r$pkgrel
Natanael Copa's avatar
Natanael Copa committed
812 813 814 815 816
pkgdesc = $pkgdesc
url = $url
builddate = $builddate
packager = ${PACKAGER:-"Unknown"}
size = $size
Natanael Copa's avatar
Natanael Copa committed
817
arch = $parch
818
origin = $pkgname
Natanael Copa's avatar
Natanael Copa committed
819
EOF
820 821
	local i deps
	deps="$depends"
822
	if [ "$pkgname" != "busybox" ] && ! depends_has busybox; then
823 824
		for i in $install $triggers; do
			local s=${i%=*}
825
			[ "$name" != "${s%.*}" ] && continue
826
			if head -n 1 "$startdir/$s" | grep '^#!/bin/sh' >/dev/null ; then
827 828 829 830 831
				msg "Script found. busybox added as a dependency for $pkg"
				deps="$deps busybox"
				break
			fi
		done
832
	fi
833

834 835 836
	# store last_commit in global var so we only call git once
	if [ -z "$last_commit" ]; then
		last_commit="$(git_last_commit)$(git_dirty)"
837
	fi
838
	echo "commit = $last_commit" >> "$pkginfo"
839

840
	get_maintainer
841 842 843 844
	if [ -n "$maintainer" ]; then
		echo "maintainer = $maintainer" >> "$pkginfo"
	fi

845
	if [ -n "$replaces_priority" ]; then
846
		echo "replaces_priority = $replaces_priority" >> "$pkginfo"
847 848
	fi

849
	echo "license = $license" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
850
	for i in $replaces; do
851
		echo "replaces = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
852
	done
853
	for i in $deps; do
854
		echo "depend = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
855 856
	done
	for i in $provides; do
857
		echo "provides = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
858
	done
859 860 861 862 863 864
	for i in $triggers; do
		local f=${i%=*}
		local dirs=${i#*=}
		[ "${f%.trigger}" != "$name" ] && continue
		echo "triggers = ${dirs//:/ }" >> "$pkginfo"
	done
865 866 867
	if [ -n "$install_if" ]; then
		echo "install_if = $(echo $install_if)" >> "$pkginfo"
	fi
Natanael Copa's avatar
Natanael Copa committed
868 869

	local metafiles=".PKGINFO"
870 871 872
	for i in $install $triggers; do
		local f=${i%=*}
		local n=${f%.*}
873
		if [ "$n" != "$name" ]; then
874 875
			continue
		fi
876
		script=${f#$name}
877
		msg "Adding $script"
878
		cp "$startdir/$f" "$controldir/$script" || return 1
879
		chmod +x "$controldir/$script"
880 881
		metafiles="$metafiles $script"
	done
882
	echo $metafiles | tr ' ' '\n' > "$controldir"/.metafiles
883
}
884

885
prepare_trace_rpaths() {
886
	local dir=${subpkgdir:-$pkgdir}
887
	local etype= soname= file= sover=
888
	[ "$arch" = "noarch" ] && return 0
889
	options_has "!tracedeps" && return 0
890
	# lets tell all the places we should look for .so files - all rpaths
891 892
	scanelf --quiet --recursive --rpath "$dir" \
		| sed -e 's/[[:space:]].*//' -e 's/:/\n/' | sort -u \
893
		>"$controldir"/.rpaths
894
	if grep -q -x '/usr/lib' "$controldir"/.rpaths; then
895
		warning "Redundant /usr/lib in rpath found"
896 897 898 899 900
	fi
	if grep '^/home/' "$controldir"/.rpaths; then
		error "Has /home/... in rpath"
		return 1
	fi
Natanael Copa's avatar
Natanael Copa committed
901 902
}

903 904
# search for broken symlinks so we later can pull in proper depends
prepare_symlinks() {
905
	local target
906 907 908 909
	local dir="${subpkgdir:-$pkgdir}"
	options_has "!tracedeps" && return 0
	cd "$dir" || return 1
	find -type l | while read symlink; do
910 911 912
		target=$(readlink "$symlink")
		if ! [ -e "$dir$(normalize_target_path "$target" "$symlink")" ]; then
			echo "$symlink $target" >> "$controldir"/.symlinks
913 914 915 916
		fi
	done
}

917 918 919 920 921 922 923 924 925 926
prepare_pkgconfig_provides() {
	local dir="${subpkgdir:-$pkgdir}"
	options_has "!tracedeps" && return 0
	cd "$dir" || return 1
	for i in usr/lib/pkgconfig/*.pc; do
		if ! [ -e "$i" ]; then
			continue
		fi
		local f=${i##*/}
		local v=$(PKG_CONFIG_PATH="$dir"/usr/lib/pkgconfig pkg-config \
927
			--modversion ${f%.pc})
928 929 930 931
		echo "${f%.pc}=${v:-0}" >> "$controldir"/.provides-pc
	done
}

932 933 934 935 936 937 938 939 940 941 942 943
# check if dir has arch specific binaries
dir_has_arch_binaries() {
	local dir="$1"
	# if scanelf returns something, then we have binaries
	[ -n "$(scanelf -R "$dir" | head -n 1)" ] && return 0

	# look for static *.a
	[ -n "$(find "$dir" -type f -name '*.a' | head -n 1)" ] && return 0

	return 1
}

944 945 946 947 948
# returns true if this is the -dev package
is_dev_pkg() {
	test "${subpkgname%-dev}" != "$subpkgname"
}

949 950
# returns true if this is the -doc package
is_doc_pkg() {
951
	test "${1%-doc}" != "$1"
952 953
}

954 955 956 957 958 959 960
# check that noarch is set if needed
archcheck() {
	options_has "!archcheck" && return 0
	if dir_has_arch_binaries "${subpkgdir:-$pkgdir}"; then
		[ "$arch" != "noarch" ] && return 0
		error "Arch specific binaries found so arch must not be set to \"noarch\""
		return 1
961 962 963
	elif [ "$arch" != "noarch" ] && ! is_dev_pkg; then
		# we dont want -dev package go to noarch
		warning "No arch specific binaries found so arch should probably be set to \"noarch\""
964 965 966 967
	fi
	return 0
}

968
prepare_package() {
969
	msg "Preparing ${subpkgname:+sub}package ${subpkgname:-$pkgname}..."
970
	stripbin
971 972 973 974
	prepare_metafiles \
		&& prepare_trace_rpaths \
		&& prepare_symlinks \
		&& prepare_pkgconfig_provides \
975
		|| return 1
976
	archcheck
977 978 979 980 981 982 983 984
}

pkginfo_val() {
	local key="$1"
	local file="$2"
	awk -F ' = ' "\$1 == \"$key\" {print \$2}" "$file"
}

985 986 987 988 989 990 991 992 993 994 995 996 997 998 999 1000 1001 1002 1003 1004 1005 1006 1007
# find real path to so files
real_so_path() {
	local so="$1"
	shift
	while [ $# -gt 0 ]; do
		[ -e "$1"/$so ] && realpath "$1/$so" && return 0
		shift
	done
	error "$so: path not found"
	return 1
}

# search rpaths and /usr/lib /lib for given so files
find_so_files() {
	local rpaths=$(cat "$1")
	shift
	while [ $# -gt 0 ]; do
		real_so_path "$1" /usr/lib /lib $rpaths || return 1
		shift
	done
	return 0
}

1008 1009 1010 1011 1012
subpkg_provides_prefixed_so() {
	[ -n "$sonameprefix" ] && grep -q -w "^$sonameprefix$1" \
		"$pkgbasedir"/.control.*/.provides-so 2>/dev/null
}

1013
subpkg_provides_so() {
1014 1015 1016
	grep -q -w "^$1" "$pkgbasedir"/.control.*/.provides-so 2>/dev/null
}

1017
subpkg_provides_pc() {
1018 1019
	grep -q -w "^${1%%[<>=]*}" "$pkgbasedir"/.control.*/.provides-pc \
		2>/dev/null
1020 1021
}

1022 1023 1024
trace_apk_deps() {
	local name="$1"
	local dir="$2"
1025
	local i= found= autodeps= deppkgs= missing=
1026
	msg "Tracing dependencies..."
1027 1028 1029
	# add pkgconfig if usr/lib/pkgconfig is found
	if [ -d "$pkgbasedir"/$name/usr/lib/pkgconfig ] \
			&& ! grep -q '^depend = pkgconfig' "$dir"/.PKGINFO; then
1030 1031 1032 1033
		autodeps="$autodeps pkgconfig"
	fi

	# special case for libpthread: we need depend on libgcc
1034 1035
	if [ "$CLIBC" = "uclibc" ] && [ -f "$dir"/.needs-so ] \
			&& grep -q -w '^libpthread.so.*' "$dir"/.needs-so \
1036 1037
			&& ! grep -q -w "^depend = libgcc" "$dir"/.PKGINFO; then
		autodeps="$autodeps libgcc"
1038
		msg "  added libgcc (due to libpthread)"
1039
	fi
1040

1041
	[ -f "$dir"/.needs-so ] && for i in $(cat "$dir"/.needs-so); do
1042
		# first check if its provided by same apkbuild
1043
		grep -q -w "^$sonameprefix$i" "$dir"/.provides-so 2>/dev/null && continue
1044

1045 1046 1047
		if subpkg_provides_prefixed_so "$i"; then
			autodeps="$autodeps so:$sonameprefix$i"
		elif subpkg_provides_so "$i" || cross_compiling \
1048
				|| $APK info --quiet --installed "so:$i"; then
1049
			autodeps="$autodeps so:$i"
1050
		else
1051
			missing="$missing $i"
1052
		fi
1053 1054 1055
	done

	# find all packages that holds the so files
1056
	if [ -f "$dir"/.rpaths ]; then
1057 1058
		local so_files=$(find_so_files "$dir"/.rpaths $missing) \
			|| return 1
1059
		deppkgs=$($APK info --quiet --who-owns $so_files) || return 1
1060 1061
	fi

1062
	for found in $deppkgs; do
1063
		if grep -w "^depend = ${found}$" "$dir"/.PKGINFO >/dev/null ; then
1064 1065 1066
			warning "You can remove '$found' from depends"
			continue
		fi
1067
		autodeps="$autodeps $found"
1068
	done
1069

1070 1071 1072 1073 1074
	# symlink targets
	for i in $(sort -u "$dir"/.symlinks-needs 2>/dev/null); do
		autodeps="$autodeps $i"
	done

1075 1076 1077 1078
	# pkg-config depends
	for i in $(sort -u "$dir"/.needs-pc 2>/dev/null); do
		if subpkg_provides_pc "$i" || cross_compiling \
				|| $APK info --quiet --installed "pc:$i"; then
1079 1080 1081 1082
			local provider=$(apk search --quiet "pc:$i")
			if list_has "$provider" $depends_dev; then
				warning "$provider should be removed from depends_dev"
			fi
1083
			autodeps="$autodeps pc:$i"
1084 1085 1086 1087 1088 1089 1090
		else
			warning "Could not find any provider for pc:$i"
			local pcfile=/usr/lib/pkgconfig/"${i%%[<>=]*}".pc
			if [ -e "$pcfile" ]; then
				local owner=$($APK info --quiet --who-owns $pcfile)
				warning "${owner:-package providing $pcfile} needs to be rebuilt"
			fi
1091 1092 1093
		fi
	done

1094
	echo "# automatically detected:" >> "$dir"/.PKGINFO
1095
	if [ -f "$dir"/.provides-so ]; then
1096 1097
		sed 's/^\(.*\) \([0-9].*\)/provides = so:\1=\2/' \
			"$dir"/.provides-so | sort -u \
1098
			>> "$dir"/.PKGINFO
1099
	fi
1100
	if [ -f "$dir"/.provides-pc ]; then
1101
		sed 's/^/provides = pc:/' "$dir"/.provides-pc | sort -u \
1102 1103
			>> "$dir"/.PKGINFO
	fi
1104
	[ -z "$autodeps"